.386P

EXTRN _asm1 : dword
EXTRN _asm2 : dword
EXTRN _asm3 : dword
EXTRN _asm4 : dword
EXTRN _haddtable : dword

CODE SEGMENT BYTE PUBLIC USE32 'CODE'
ASSUME cs:CODE

PUBLIC setxdim_
setxdim_:
	mov dword ptr ds:[xdim2+2], eax
	mov dword ptr ds:[mxdim2+2], eax
	ret

PUBLIC setupdline_
setupdline_:
	mov dword ptr ds:[mach1a+2], eax
	mov dword ptr ds:[mach1b+2], eax
	mov dword ptr ds:[mask1+2], ebx
	mov byte ptr ds:[shx1+2], ch
	mov byte ptr ds:[shx2+2], ch
	mov byte ptr ds:[shx3+2], ch
	mov byte ptr ds:[shy1+2], cl
	mov byte ptr ds:[shy2+2], cl
	mov byte ptr ds:[shy3+2], cl
	ret

PUBLIC dline_
dline_:
	;_asm1 = bxinc
	;_asm2 = byinc
	;_asm3 = shadeoffs
	;eax =   bx
	;ebx =   by
	;ecx =                    cnt
	;edx =   scry<<2
	;esi =   picoffs
	;edi =   videopos

	test ecx, ecx
	jnz startlongdline

shx3: rol eax, 7                           ;edx assumed to start < 65536
	mov dh, al
shy3: rol ebx, 7
	mov dl, bl
	mov eax, _asm3
mach1b: mov cl, byte ptr [edx+88888888h]   ;picoffs
	mov al, byte ptr [ecx+eax]              ;shadeoffs
	mov byte ptr [edi], al
	ret

	nop
	nop
	nop
	nop
	nop
	nop
	nop

startlongdline:
	push ebp
	mov esi, edx

shx1: rol eax, 7                   ;edx assumed to start < 65536
	mov dh, al
	and eax, 0ffff0000h
shy1: rol ebx, 7
	mov dl, bl
	and ebx, 0ffff0000h

	mov ebp, eax

	lea ecx, [ecx*4+1]
	lea eax, [_haddtable+ecx+esi]
	mov dword ptr ds:[hadd+2], eax
	xor esi, esi
	sub esi, ecx
	xor ecx, ecx

	mov eax, _asm3
	mov dword ptr ds:[mach6a+2], eax

	mov eax, _asm1
shx2: rol eax, 7
	mov byte ptr ds:[mach3a+2], al
	and eax, 0ffff0000h
	mov dword ptr ds:[mach2a+2], eax

	mov eax, _asm2
shy2: rol eax, 7
	mov byte ptr ds:[mach5a+2], al
	and eax, 0ffff0000h
	mov dword ptr ds:[mach4a+2], eax

	jmp short begdline
begdline:
mach2a: add ebp, 88880000h
mach1a: mov cl, byte ptr [edx+88888888h]   ;picoffs
mach3a: adc dh, 88h
mach4a: add ebx, 88880000h
mach5a: adc dl, 88h
mach6a: mov al, byte ptr [ecx+88888888h]   ;shadeoffs
	mov byte ptr [edi], al
mask1: and edx, 00007f7fh                  ;mask
hadd: add edi, dword ptr [esi+88888888h]   ;_haddtable
	add esi, 4
	jnc short begdline

	pop ebp
	ret

PUBLIC setupvline_
setupvline_:
	mov dword ptr ds:[mach1c+2], eax
	mov dword ptr ds:[mask3+2], ebx
	mov byte ptr ds:[shx5+2], ch
	mov byte ptr ds:[shx6+2], ch
	mov byte ptr ds:[shy5+2], cl
	mov byte ptr ds:[shy6+2], cl
	ret

PUBLIC vline_
vline_:
	;_asm1 = bxinc
	;_asm2 = byinc
	;_asm3 = shadeoffs
	;eax =   bx
	;ebx =   by
	;ecx =                    cnt
	;edx =   0
	;esi =   picoffs
	;edi =   videopos

	push ebp

shx5: rol eax, 7
	mov dh, al
	and eax, 0ffff0000h
shy5: rol ebx, 7
	mov dl, bl
	and ebx, 0ffff0000h

	mov ebp, eax

	mov bx, cx
	inc bl
	inc bh
	xor ecx, ecx

	mov eax, _asm3
	mov dword ptr ds:[mach6c+2], eax

	mov eax, _asm1
shx6: rol eax, 7
	mov byte ptr ds:[mach3c+2], al
	and eax, 0ffff0000h
	mov dword ptr ds:[mach2c+2], eax

	mov eax, _asm2
shy6: rol eax, 7
	mov byte ptr ds:[mach5c+2], al
	and eax, 0ffff0000h
	mov dword ptr ds:[mach4c+2], eax

	jmp short begvline
begvline:
mach2c: add ebp, 88880000h
mach1c: mov cl, byte ptr [edx+88888888h]   ;picoffs
mach3c: adc dh, 88h
mach4c: add ebx, 88880000h
mach5c: adc dl, 88h
mach6c: mov al, byte ptr [ecx+88888888h]   ;shadeoffs
	mov byte ptr [edi], al
mask3: and edx, 00007f7fh                  ;mask
xdim2: add edi, 88888888h                  ;XDIM
	dec bl
	jnz short begvline
	dec bh
	jnz short begvline

	pop ebp
	ret

PUBLIC setuphline_
setuphline_:
	mov dword ptr ds:[mach1d+2], eax
	mov dword ptr ds:[mach7d+2], eax
	mov dword ptr ds:[mach13d+2], eax
	mov dword ptr ds:[mask4+2], ebx
	mov dword ptr ds:[mask5+2], ebx
	mov dword ptr ds:[mask6+2], ebx
	mov byte ptr ds:[shx7+2], ch
	mov byte ptr ds:[shx8+2], ch
	mov byte ptr ds:[shy7+2], cl
	mov byte ptr ds:[shy8+2], cl
	ret

PUBLIC hline_
hline_:
	;_asm1 = bxinc
	;_asm2 = byinc
	;_asm3 = shadeoffs
	;eax =   bx
	;ebx =   by
	;ecx =                    cnt
	;edx =   0
	;esi =   picoffs
	;edi =   videopos

	push ebp

	inc ecx
	add edi, ecx
	mov dword ptr ds:[mach19d+2], edi
	mov dword ptr ds:[mach20d+3], edi
	xor edi, edi
	sub edi, ecx
	xor ecx, ecx

shx7: rol eax, 7
	mov dh, al
	and eax, 0ffff0000h
shy7: rol ebx, 7
	mov dl, bl
	and ebx, 0ffff0000h

	mov ebp, eax

	mov eax, _asm3
	mov dword ptr ds:[mach6d+2], eax
	mov dword ptr ds:[mach12d+2], eax
	mov dword ptr ds:[mach18d+2], eax

	mov eax, _asm1
shx8: rol eax, 7
	mov byte ptr ds:[mach3d+2], al
	mov byte ptr ds:[mach9d+2], al
	mov byte ptr ds:[mach15d+2], al
	and eax, 0ffff0000h
	mov dword ptr ds:[mach2d+2], eax
	mov dword ptr ds:[mach8d+2], eax
	mov dword ptr ds:[mach14d+2], eax

	mov eax, _asm2
shy8: rol eax, 7
	mov byte ptr ds:[mach5d+2], al
	mov byte ptr ds:[mach11d+2], al
	mov byte ptr ds:[mach17d+2], al
	and eax, 0ffff0000h
	mov dword ptr ds:[mach4d+2], eax
	mov dword ptr ds:[mach10d+2], eax
	mov dword ptr ds:[mach16d+2], eax

	test edi, 1
	jz beghline
	jmp short hlinekillcache
hlinekillcache:

mach14d: add ebp, 88880000h
mach13d: mov cl, byte ptr [edx+88888888h]   ;picoffs
mach15d: adc dh, 88h
mach16d: add ebx, 88880000h
mach17d: adc dl, 88h
mach18d: mov al, byte ptr [ecx+88888888h]   ;shadeoffs
mach19d: mov byte ptr [edi+88888888h], al
mask4: and edx, 00007f7fh                   ;mask
	inc edi
	jz endline

beghline:
mach2d: add ebp, 88880000h
mach1d: mov cl, byte ptr [edx+88888888h]   ;picoffs
mach3d: adc dh, 88h
mach4d: add ebx, 88880000h
mach5d: adc dl, 88h
mach6d: mov al, byte ptr [ecx+88888888h]   ;shadeoffs
mask5: and edx, 00007f7fh                  ;mask

mach8d: add ebp, 88880000h
mach7d: mov cl, byte ptr [edx+88888888h]   ;picoffs
mach9d: adc dh, 88h
mach10d: add ebx, 88880000h
mach11d: adc dl, 88h
mach12d: mov ah, byte ptr [ecx+88888888h]   ;shadeoffs
mask6: and edx, 00007f7fh                   ;mask

mach20d: mov word ptr [edi+88888888h], ax
	add edi, 2
	jnc short beghline

endline:
	pop ebp
	ret

PUBLIC msetupdline_
msetupdline_:
	mov dword ptr ds:[mmach1a+2], eax
	mov dword ptr ds:[mmask1+2], ebx
	mov byte ptr ds:[mshx1+2], ch
	mov byte ptr ds:[mshx2+2], ch
	mov byte ptr ds:[mshy1+2], cl
	mov byte ptr ds:[mshy2+2], cl
	ret

	PUBLIC mdline_
mdline_:
	;_asm1 = bxinc
	;_asm2 = byinc
	;_asm3 = shadeoffs
	;eax =   bx
	;ebx =   by
	;ecx =                    cnt
	;edx =   scry<<2
	;esi =   picoffs
	;edi =   videopos

	push ebp

	mov esi, edx
	xor edx, edx

mshx1: rol eax, 7
	mov dh, al
	and eax, 0ffff0000h
mshy1: rol ebx, 7
	mov dl, bl
	and ebx, 0ffff0000h

	mov ebp, eax

	lea ecx, [ecx*4+1]
	lea eax, [_haddtable+ecx+esi]
	mov dword ptr ds:[mhadd+2], eax
	xor esi, esi
	sub esi, ecx
	xor ecx, ecx

	mov eax, _asm3
	mov dword ptr ds:[mmach6a+2], eax

	mov eax, _asm1
mshx2: rol eax, 7
	mov byte ptr ds:[mmach3a+2], al
	and eax, 0ffff0000h
	mov dword ptr ds:[mmach2a+2], eax

	mov eax, _asm2
mshy2: rol eax, 7
	mov byte ptr ds:[mmach5a+2], al
	and eax, 0ffff0000h
	mov dword ptr ds:[mmach4a+2], eax

	jmp short mbegdline
mbegdline:
mmach2a: add ebp, 88880000h
mmach1a: mov cl, byte ptr [edx+88888888h]   ;picoffs
mmach3a: adc dh, 88h
mmach4a: add ebx, 88880000h
mmach5a: adc dl, 88h
	cmp cl, 255
	je mskip1
mmach6a: mov al, byte ptr [ecx+88888888h]   ;shadeoffs
	mov byte ptr [edi], al
mskip1:
mmask1: and edx, 00007f7fh                  ;mask
mhadd: add edi, dword ptr [esi+88888888h]   ;_haddtable
	add esi, 4
	jnc short mbegdline

	pop ebp
	ret

PUBLIC msetupvline_
msetupvline_:
	mov dword ptr ds:[mmach1c+2], eax
	mov dword ptr ds:[mask9+2], ebx
	mov byte ptr ds:[mshx5+2], ch
	mov byte ptr ds:[mshx6+2], ch
	mov byte ptr ds:[mshy5+2], cl
	mov byte ptr ds:[mshy6+2], cl
	ret

PUBLIC mvline_
mvline_:
	;_asm1 = bxinc
	;_asm2 = byinc
	;_asm3 = shadeoffs
	;eax =   bx
	;ebx =   by
	;ecx =                    cnt
	;edx =   0
	;esi =   picoffs
	;edi =   videopos

	push ebp

mshx5: rol eax, 7
	mov dh, al
	and eax, 0ffff0000h
mshy5: rol ebx, 7
	mov dl, bl
	and ebx, 0ffff0000h

	mov ebp, eax

	mov bx, cx
	inc bl
	inc bh
	xor ecx, ecx

	mov eax, _asm3
	mov dword ptr ds:[mmach6c+2], eax

	mov eax, _asm1
mshx6: rol eax, 7
	mov byte ptr ds:[mmach3c+2], al
	and eax, 0ffff0000h
	mov dword ptr ds:[mmach2c+2], eax

	mov eax, _asm2
mshy6: rol eax, 7
	mov byte ptr ds:[mmach5c+2], al
	and eax, 0ffff0000h
	mov dword ptr ds:[mmach4c+2], eax

	jmp short mbegvline
mbegvline:
mmach2c: add ebp, 88880000h
mmach1c: mov cl, byte ptr [edx+88888888h]   ;picoffs
mmach3c: adc dh, 88h
mmach4c: add ebx, 88880000h
mmach5c: adc dl, 88h
	cmp cl, 255
	je mskip3
mmach6c: mov al, byte ptr [ecx+88888888h]   ;shadeoffs
	mov byte ptr [edi], al
mskip3:
mask9: and edx, 00007f7fh                   ;mask
mxdim2: add edi, 88888888h                  ;XDIM
	dec bl
	jnz short mbegvline
	dec bh
	jnz short mbegvline

	pop ebp
	ret

PUBLIC msetuphline_
msetuphline_:
	mov dword ptr ds:[mmach1d+2], eax
	mov dword ptr ds:[mask10+2], ebx
	mov byte ptr ds:[mshx7+2], ch
	mov byte ptr ds:[mshx8+2], ch
	mov byte ptr ds:[mshy7+2], cl
	mov byte ptr ds:[mshy8+2], cl
	ret

PUBLIC mhline_
mhline_:
	;_asm1 = bxinc
	;_asm2 = byinc
	;_asm3 = shadeoffs
	;eax =   bx
	;ebx =   by
	;ecx =                    cnt
	;edx =   0
	;esi =   picoffs
	;edi =   videopos

	push ebp

	inc ecx
	add edi, ecx
	mov dword ptr ds:[mmach19d+2], edi
	xor edi, edi
	sub edi, ecx
	xor ecx, ecx

mshx7: rol eax, 7
	mov dh, al
	and eax, 0ffff0000h
mshy7: rol ebx, 7
	mov dl, bl
	and ebx, 0ffff0000h

	mov ebp, eax

	mov eax, _asm3
	mov dword ptr ds:[mmach6d+2], eax

	mov eax, _asm1
mshx8: rol eax, 7
	mov byte ptr ds:[mmach3d+2], al
	and eax, 0ffff0000h
	mov dword ptr ds:[mmach2d+2], eax

	mov eax, _asm2
mshy8: rol eax, 7
	mov byte ptr ds:[mmach5d+2], al
	and eax, 0ffff0000h
	mov dword ptr ds:[mmach4d+2], eax

	jmp short mbeghline
mbeghline:
mmach2d: add ebp, 88880000h
mmach1d: mov cl, byte ptr [edx+88888888h]   ;picoffs
mmach3d: adc dh, 88h
mmach4d: add ebx, 88880000h
mmach5d: adc dl, 88h
	cmp cl, 255
	je mskip4
mmach6d: mov al, byte ptr [ecx+88888888h]   ;shadeoffs
mmach19d: mov byte ptr [edi+88888888h], al
mskip4:
mask10: and edx, 00007f7fh                  ;mask
	inc edi
	jnz short mbeghline

	pop ebp
	ret

CODE ENDS
END
